<?php
/**
 * @file - Page callbacks
 */

/**
 * node/1234/repeats page callback
 *
 * @TODO Fix the remove from seequence portion
 */
function date_repeat_sequence_page($node) {
  $out = '';
  if (empty($node->date_repeat_sequences)) {
    return date_repeat_page($node);
  }
  foreach ($node->date_repeat_sequences as $seq) {
    drupal_set_title(t('Date Repeats for !title', array('!title' => $node->title)));
    $title = NULL;
    $row = array();
    $rows = array();
    $headers = array(
      t('Date'),
      t('Edit !type', array('!type' => node_get_types('name', $node))),
      //t('Remove From Sequence'),
      t('Delete'),
    );
    $field = content_fields($seq['field']);
    $formatter = $field['default_format'];
    $format = date_formatter_format($formatter, $seq['field']);
    $timezone = date_get_timezone($field['tz_handling']);
    $timezone_db = date_get_timezone_db($field['tz_handling']);
    $title = '<h4>' . t('Repeats for !field', array('!field' => $field['widget']['label'])) . '</h4>';
    $title .= '<div>' . date_repeat_rrule_description($node->{$seq['field']}[0]['rrule']) . '</div>';
    $content_db = content_database_info($field);
    $table = $content_db['table'];
    $column = array_shift($content_db['columns']);
    $sql = 'SELECT n.nid, c.' . $column['column'] . ' date FROM {date_repeat_sequence_node} dn
      JOIN {node} n ON n.nid = dn.nid
      JOIN {' . $table . '} c ON c.vid = n.vid
      WHERE dn.sqid = %d
      ORDER BY c.' . $column['column'] . ' ASC';
    $results = db_query($sql, $seq['sqid']);
    
    while ($result = db_fetch_object($results)) {
      $row = array();
      
      $date = date_make_date($result->date, $timezone_db, $field['type'], $field['granularity']);
      $row[] = l(date_format_date($date, $format), 'node/' . $result->nid);
      $row[] = l('Edit', 'node/' . $result->nid . '/edit');
      //$row[] = l('Remove', 'node/' . $result->nid . '/seq_remove');
      $row[] = l('Delete', 'node/' . $result->nid . '/delete');
      $rows[] = $row;
    }

    $out .= $title . theme('table',$headers, $rows);
  }
  return $out;
}

/**
 * Menu callback -- ask for confirmation of node deletion
 */
function date_repeat_node_delete_confirm(&$form_state, $node) {
  $form['node'] = array(
    '#type' => 'value',
    '#value' => $node,
  );
  if (date_repeat_sequence_node($node)) {
    module_load_include('inc', 'date_repeat_sequence', 'date_repeat_sequence_form');
    foreach (element_children($node) as $field) {
      if (date_repeat_sequence_is_field($field) && isset($node->date_repeat_sequences[$field])) {
        $field_settings = content_fields($field);
        if($field_settings['widget']['sequence']['show_edit']) {
          $form['edit_options'][$field] = _date_repeat_sequence_edit_options($field_settings);
          $form['edit_options'][$field]['options']['#title'] = $field_settings['widget']['label'] . ' ' . $form['edit_options'][$field]['options']['#title'];
        }
        else {
          $form['date_repeat_sequence_edit'][$field] = array(
            '#type' => 'value',
            '#value' => $field_settings['widget']['sequence']['edit_default'],
          );
        }  
      }
    }
  }
  return confirm_form($form,
    t('Are you sure you want to delete %title?', array('%title' => $node->title)),
    isset($_GET['destination']) ? $_GET['destination'] : 'node/'. $node->nid,
    t('This action cannot be undone.'),
    t('Delete'),
    t('Cancel')
  );
}

/**
 * Execute node deletion
 */
function date_repeat_node_delete_confirm_submit($form, &$form_state) {
  if ($form_state['values']['confirm']) {
    if (empty($form_state['values']['date_repeat_sequence_edit'])) {
      node_delete($form_state['values']['node']->nid);
    }
    else {
      $node = $form_state['values']['node'];
      $node->date_repeat_sequence_edit = $form_state['values']['date_repeat_sequence_edit'];
      module_load_include('inc', 'date_repeat_sequence', 'date_repeat_sequence.node');
      _drs_node_delete($node);
    }
  }

  $form_state['redirect'] = '<front>';
}